//GrundlinienRaster_401d.js / CS4
// 08.12.08 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//Ein Script zum Anpassen des Grundlinienrasters

if (app.documents.length == 0) {
	alert ("Bitte ein Dokument ffnen.", "Achtung");
	exit();
}

// den Nullpunkt auf Null/Null setzen
app.documents[0].zeroPoint = [0,0];

// den aktuellen Schrittwert feststellen und in Punkte umrechnen
var curDoc = app.documents[0];
var oldStep = (curDoc.gridPreferences.baselineDivision)/0.352777777778;
oldStep = Math.floor((oldStep*1000)+0.5)/1000;

// prfen, welche Option aktiv ist
var curOpt = curDoc.gridPreferences.baselineGridRelativeOption;

// Dialoge lschen, welche offen geblieben sind
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

// einen Dialog vorbereiten
var oldStart = curDoc.gridPreferences.baselineStart;
var maxVal = 234;
if (maxVal < oldStep) {
	maxVal = oldStep;
}
var aDialog = app.dialogs.add({name:"Grundlinenraster", canCancel:true});
with (aDialog) {
	with (dialogColumns.add()) {
		with (dialogRows.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Einteilung alle:", minWidth:134});
						var oldStepVal = realEditboxes.add({editValue:oldStep, minimumValue:1, maximumValue:maxVal, minWidth:40});
						staticTexts.add({staticLabel:"pt", minWidth:4});
						staticTexts.add({staticLabel:" ", minWidth:4});
					}
				}
			}
		}
		with (dialogRows.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Abstand Satzspiegel:"});
						var aOffVal = realEditboxes.add({editValue:0, minimumValue:-10, maximumValue:10, minWidth:40});
						staticTexts.add({staticLabel:"mm"});
					}
				}
			}
		}
		with (dialogRows.add()){
			staticTexts.add({staticLabel:" ", minWidth:42});
			with(aligButtons = radiobuttonGroups.add()){
				radiobuttonControls.add({staticLabel:"Satzspiegelaliniert (unten)", checkedState:true});
				radiobuttonControls.add({staticLabel:"Nicht alinieren"});
			}
		}
		with (dialogRows.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Anfang:", minWidth:110});
						var oldStartVal = realEditboxes.add({editValue:oldStart, minimumValue:0, maximumValue:123, minWidth:60});
						staticTexts.add({staticLabel:"mm"});
					}
				}
			}
		}
		with (dialogColumns.add()) {
			staticTexts.add({staticLabel:"", minWidth:4});
		}
	}
}

// den Dialog zeigen und auswerten
if (aDialog.show() == true) {
	var newStepVal = oldStepVal.editValue * 0.352777777778;
	var aOff = aOffVal.editValue
	var aligDec = aligButtons.selectedButton;
	var newStart = oldStartVal.editValue;
	// den Dialog lschen
	aDialog.destroy();
}
else {
	aDialog.destroy();
	exit();
}

// die Werte vorbereiten und anwenden
if (aligDec == 0) {
	if (curOpt == 1162766196) {
		var topPos = 0;
	}
	else {
		var topPos = app.activeWindow.activePage.marginPreferences.top;
	}
	var oldStart = curDoc.gridPreferences.baselineStart;
	var botMargin = app.activeWindow.activePage.marginPreferences.bottom;
	var botPos = (curDoc.pages[0].bounds[2] - botMargin) - aOff;
	var aDiff = (botPos - oldStart - topPos) % newStepVal;
	var newStart = (oldStart + aDiff) - newStepVal;
	if (newStart < 0) {
		newStart = newStart + newStepVal;
	}
	curDoc.gridPreferences.baselineStart = newStart;
	curDoc.gridPreferences.baselineDivision = newStepVal;
}
else {
	curDoc.gridPreferences.baselineStart = newStart;
	curDoc.gridPreferences.baselineDivision = newStepVal;
}